//
//  EventViewController.m
//  Locations
//
//  Created by Ray Kiddy on 7/2/09.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import "EventViewController.h"

#import "LocationsAppDelegate.h"

#import "KeyValueController.h"

@implementation EventViewController

@synthesize event;
@synthesize addButton;

#pragma mark -
#pragma mark UITableViewDelegate methods

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
	return [[event attributeNames] count];
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {

    static NSString * CellIdentifier = @"Cell";

    // Dequeue or create a new cell
	//
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) { 
		cell = [[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleSubtitle reuseIdentifier:CellIdentifier] autorelease];
    }

	cell.textLabel.text = [[event valueForKey:[[event attributeNames] objectAtIndex:indexPath.row]] description];
	cell.detailTextLabel.text = [[event attributeNames] objectAtIndex:indexPath.row];

    return cell;
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {

	[tableView deselectRowAtIndexPath:indexPath animated:NO];

	KeyValueController * eventController = [[KeyValueController alloc] init];

	[eventController setAttributeName:[[event attributeNames] objectAtIndex:indexPath.row]];
	[eventController setEvent:self.event];

	[[LocationsAppDelegate delegate].navigationController pushViewController:eventController animated:YES];
	[eventController release];
}

- (void)addAttribute {
	KeyValueController * eventController = [[KeyValueController alloc] init];
	
	[eventController setAttributeName:@"extra"];
	[eventController setEvent:self.event];
	
	[[LocationsAppDelegate delegate].navigationController pushViewController:eventController animated:YES];
	[eventController release];
}

#pragma mark -
#pragma mark UIViewController method overrides

- (void)viewDidLoad {

    [super viewDidLoad];

    // Set the title.
    self.title = [[event entity] name];

	addButton = [[UIBarButtonItem alloc] initWithBarButtonSystemItem:UIBarButtonSystemItemAdd target:self action:@selector(addAttribute)];
    addButton.enabled = YES;
    self.navigationItem.rightBarButtonItem = addButton;	
}

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];

	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}

- (void)dealloc {
	[event release];

    [super dealloc];
}


@end
