// 
//  Event.m
//  Locations
//
//  Created by Ray Kiddy on 7/19/09.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import "Event.h"

#import "PartyFavor.h"

@implementation Event 

@dynamic creationDate;
@dynamic longitude;
@dynamic latitude;
@dynamic partyFavors;
@dynamic extras;

- (NSString *)description {
	
	// A date formatter for the time stamp
	//
    static NSDateFormatter *dateFormatter = nil;
	
    if (dateFormatter == nil) {
        dateFormatter = [[NSDateFormatter alloc] init];
        [dateFormatter setTimeStyle:NSDateFormatterMediumStyle];
        [dateFormatter setDateStyle:NSDateFormatterMediumStyle];
    }
	
	return [dateFormatter stringFromDate:[self creationDate]];
}

- (NSString *)subdescription {
	
	// A number formatter for the latitude and longitude
	//
    static NSNumberFormatter *numberFormatter = nil;
	
    if (numberFormatter == NULL) {
        numberFormatter = [[NSNumberFormatter alloc] init];
        [numberFormatter setNumberStyle:NSNumberFormatterDecimalStyle];
        [numberFormatter setMaximumFractionDigits:3];
    }
	
	return [NSString stringWithFormat:@"%@, %@", [numberFormatter stringFromNumber:self.latitude], [numberFormatter stringFromNumber:self.longitude]];
}

- (id)valueForUndefinedKey:(NSString *)name {
	
	NSArray * extra = [[self extras] allObjects];
	for (int idx = 0; idx < [extra count]; idx++) {
		if ([name isEqualToString:[[extra objectAtIndex:idx] valueForKey:@"name"]]) {
			return [[extra objectAtIndex:idx] valueForKey:@"value"];
		}
	}
	return nil;
}

- (void)setValue:(id)value forUndefinedKey:(NSString *)name {
	
	// Look for existing object for this name. If one exists, replace its value.
	NSArray * extra = [[self extras] allObjects];
	for (int idx = 0; idx < [extra count]; idx++) {
		if ([name isEqualToString:[[extra objectAtIndex:idx] valueForKey:@"name"]]) {
			[[extra objectAtIndex:idx] setValue:value forKey:@"value"];
			return;
		}
	}
	// If an object for this name does not exist, create one.
	NSManagedObject * eventExtra = [NSEntityDescription insertNewObjectForEntityForName:@"EventExtra" inManagedObjectContext:[self managedObjectContext]];
	[eventExtra setValue:name forKey:@"name"];
	[eventExtra setValue:value forKey:@"value"];
	[self addExtrasObject:eventExtra];
}

- (NSArray *)attributeNames {

	NSEntityDescription * extrasEntity = [[[[self entity] managedObjectModel] entitiesByName] objectForKey:@"EventExtra"];

	NSFetchRequest * request = [[NSFetchRequest alloc] init];
	[request setEntity:extrasEntity];
	
	NSArray * fetchResults = [[self managedObjectContext] executeFetchRequest:request error:nil];
	
	NSMutableSet * extraAttributes = [[NSMutableSet alloc] initWithSet:[NSSet setWithArray:[[[self entity] attributesByName] allKeys]]];

	NSArray * foundNames = [fetchResults valueForKey:@"name"];

	for (int idx = 0; idx < [foundNames count]; idx++) {
		if ([foundNames objectAtIndex:idx] != [NSNull null])
			[extraAttributes addObject:[foundNames objectAtIndex:idx]];
	}

	return [extraAttributes allObjects];
}

@end
