//
//  NSOperation+Blocks.h
//  NSOperationBlocks
//
//  Created by Landon Fuller on 7/4/09.
//  Copyright 2009 Plausible Labs Cooperative, Inc.. All rights reserved.
//

#import <Foundation/Foundation.h>

@interface PLBlockOperation : NSOperation {
@private
    void (^_block)();
    id interestedObject;
}
+ (id) blockOperationWithBlock: (void (^)()) block;
- (id) initWithBlock: (void (^)()) block;

@property(assign)id interestedObject;

@end

@interface NSOperationQueue (PLBlocks)

- (void) pl_addOperationWithBlock: (void (^)()) block;
- (void)cancelOperationsFilteredByPredicate:(NSPredicate *)predicate;

@end
