#import "NSDictionary+APFinancalData.h"

@interface NSDateFormatter (yahooCSVDateFormatter)

+(NSDateFormatter *)yahooCSVDateFormatter;

@end

@implementation NSDateFormatter (yahooCSVDateFormatter)

+(NSDateFormatter *)yahooCSVDateFormatter
{
    static NSDateFormatter *df;
    if (!df) {
        NSLog(@"new date formatter");
        df = [[NSDateFormatter alloc] init];
        [df setDateFormat:@"yyyy-MM-dd"];
    }
    return df;
}

@end

@implementation  NSDictionary (APFinancalData)

+(id)dictionaryWithCSVLine:(NSString*)csvLine;
{
    // Date,Open,High,Low,Close,Volume,Adj Close
    // 2009-06-08,143.82,144.23,139.43,143.85,33255400,143.85
    
    NSMutableArray *array = [NSMutableArray arrayWithCapacity:6];
    NSScanner *scanner = [NSScanner scannerWithString:csvLine];
    NSCharacterSet *comma = [NSCharacterSet characterSetWithCharactersInString:@","];
    
    NSString *dateString = @"";
    [scanner scanUpToCharactersFromSet:comma intoString:&dateString];
    NSDate *theDate = [[NSDateFormatter yahooCSVDateFormatter] dateFromString:dateString];
    NSMutableDictionary *csvDict = [NSMutableDictionary dictionaryWithCapacity:7];
    [csvDict setObject:theDate forKey:@"date"];
    
    [scanner setCharactersToBeSkipped:comma];
    while (![scanner isAtEnd]) {
        float num;
        [scanner scanFloat:&num];
        [array addObject:[NSDecimalNumber numberWithFloat:num]];
    }

    [csvDict setObject:[array objectAtIndex:0] forKey:@"open"];
    [csvDict setObject:[array objectAtIndex:1] forKey:@"high"];
    [csvDict setObject:[array objectAtIndex:2] forKey:@"low"];    
    [csvDict setObject:[array objectAtIndex:3] forKey:@"close"];
    [csvDict setObject:[array objectAtIndex:4] forKey:@"volume"];
    [csvDict setObject:[array objectAtIndex:5] forKey:@"adjClose"];
    
    return csvDict;
}

@end
